searchNodes=[{"doc":"This is the main Xstate module. Concept An abstract state machine is a software component that defines a finite set of states: One state is defined as the initial state. When a machine starts to execute, it automatically enters this state. Each state can define actions that occur when a machine enters or exits that state. Actions will typically have side effects. Each state can define events that trigger a transition. A transition defines how a machine would react to the event, by exiting one state and entering another state. A transition can define actions that occur when the transition happens. Actions will typically have side effects. When “running” a state machine, this abstract state machine is executed. The first thing that happens is that the state machine enters the “initial state”. Then, events are passed to the machine as soon as they happen. When an event happens: The event is checked against the current state’s transitions. If a transition matches the event, that transition “happens”. By virtue of a transition “happening”, states are exited, and entered and the relevant actions are performed The machine immediately is in the new state, ready to process the next event. More resources: Finite-state machine article on Wikipedia Understanding State Machines by Mark Shead A-Level Comp Sci: Finite State Machine Top-level use : use Xstate.StateMachine","ref":"Xstate.html","title":"Xstate","type":"module"},{"doc":"Xstate is split into 3 parts: Machine : Struct used to build initialization for a machine consisting of state, events, and several other configurations. Context : A payload or extended state that is passed through the before and callback function arguments, when the transition occurs Transitions : Define how the machine reacts to events dynamically. Concepts A finite state machine is a mathematical model of computation that describes the behavior of a system that can be in only one state at any given time. For example, let's say you can be represented by a state machine with a finite number (2) of states: asleep or awake. At any given time, you're either asleep or awake. It is impossible for you to be both asleep and awake at the same time, and it is impossible for you to be neither asleep nor awake. Formally, finite state machines have five parts: A finite number of states A finite number of events An initial state A transition function that determines the next state given the current state and event A (possibly empty) set of final states State refers to some finite, qualitative &quot;mode&quot; or &quot;status&quot; of a system being modeled by a state machine, and does not describe all the (possibly infinite) data related to that system. For example, water can be in 1 of 4 states: ice, liquid, gas, or plasma. However, the temperature of water can vary and its measurement is quantitative and infinite. Layouts % StateMachine.Machine { initial_state : &quot;created&quot; , mapping : %{ :created =&gt; %{ # ^ event :confirmed_by_customer =&gt; % StateMachine.Transitions { # ^ nested event target : &quot;customer_confirmed&quot; , # ^ Value to be used for the next state before : nil , # ^ Function that&#39;s called before the transition occurs callback : nil # ^ Function that&#39;s called after the transition occurs # # Notes: `before` &amp; `callback` has a parameter of type %Context{..} # e.g: before: fn context -&gt; IO.inspect(context) end } } , ... } , modifiable_states : MapSet . new ( [ &quot;created&quot; ] ) }","ref":"Xstate.StateMachine.html","title":"Xstate.StateMachine","type":"module"},{"doc":"Check transition matches the event Support for nested key, only 2 level (e.g: &quot;create.customer_confirmed&quot;) StateMachine . can_transition? ( state , event )","ref":"Xstate.StateMachine.html#can_transition?/2","title":"Xstate.StateMachine.can_transition?/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Xstate.StateMachine.html#child_spec/1","title":"Xstate.StateMachine.child_spec/1","type":"function"},{"doc":"Accessing the current state from the machine StateMachine . get_states ( machine )","ref":"Xstate.StateMachine.html#get_states/1","title":"Xstate.StateMachine.get_states/1","type":"function"},{"doc":"Check is current state is modifiable current_state = StateMachine . get_states ( state ) StateMachine . modifiable? ( machine , current_state )","ref":"Xstate.StateMachine.html#modifiable?/2","title":"Xstate.StateMachine.modifiable?/2","type":"function"},{"doc":"Construct a new machine Parameters state : The machine state you want to construct. external : Any external value you want to pass it (e.g: ecto) StateMachine . new ( ... )","ref":"Xstate.StateMachine.html#new/2","title":"Xstate.StateMachine.new/2","type":"function"},{"doc":"Invoke transition machine : the Machine event : the event that causes the transition StateMachine . transition ( state , :created ) # Nested?, should using string StateMachine . transition ( state , &quot;created.cancel&quot; )","ref":"Xstate.StateMachine.html#transition/2","title":"Xstate.StateMachine.transition/2","type":"function"},{"doc":"","ref":"Xstate.StateMachine.html#t:t/0","title":"Xstate.StateMachine.t/0","type":"type"},{"doc":"","ref":"Xstate.StateMachine.Context.html","title":"Xstate.StateMachine.Context","type":"module"},{"doc":"Parameters: pid : PID (process identifier) event : The event that caused the transition access_time : Access time state : The resolved machine state, after transition instance : Any external value you want to pass it, passed from: external","ref":"Xstate.StateMachine.Context.html#t:t/0","title":"Xstate.StateMachine.Context.t/0","type":"type"},{"doc":"","ref":"Xstate.StateMachine.Machine.html","title":"Xstate.StateMachine.Machine","type":"module"},{"doc":"","ref":"Xstate.StateMachine.Machine.html#t:t/0","title":"Xstate.StateMachine.Machine.t/0","type":"type"},{"doc":"","ref":"Xstate.StateMachine.Transitions.html","title":"Xstate.StateMachine.Transitions","type":"module"},{"doc":"","ref":"Xstate.StateMachine.Transitions.html#t:t/0","title":"Xstate.StateMachine.Transitions.t/0","type":"type"},{"doc":"Xstate is a State Machine library for Elixir","ref":"readme.html","title":"Xstate","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding xstate to your list of dependencies in mix.exs : def deps do [ { :xstate , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Xstate - Installation","type":"extras"},{"doc":"import Xstate alias Xstate.StateMachine func = fn msg , inside -&gt; IO . puts ( &quot; \#{ msg } in \#{ inside } &quot; ) { :ok , msg } end machine = % StateMachine.Machine { initial_state : &quot;created&quot; , mapping : %{ :created =&gt; % StateMachine.Transitions { target : &quot;customer_confirmed&quot; , before : fn _ -&gt; func . ( :before_transition_ , &quot;created&quot; ) end , callback : fn _ -&gt; func . ( :after_transition , &quot;created&quot; ) end } , :customer_confirmed =&gt; % StateMachine.Transitions { target : &quot;awaiting_payment&quot; , before : nil , callback : nil } } , modifiable_states : MapSet . new ( [ &quot;created&quot; ] ) } |&gt; StateMachine . new ( ) # state before transition assert &quot;created&quot; == StateMachine . get_states ( machine ) # Invoke transition StateMachine . transition ( machine , &quot;created&quot; ) # state after transition assert &quot;customer_confirmed&quot; == StateMachine . get_states ( machine )","ref":"readme.html#usage","title":"Xstate - Usage","type":"extras"}]